//CSE124C Lab 8 Section 4 --- Haibei Zhang
//priority_queue.h

#ifndef PRIORITY_QUEUE
#define PRIORITY_QUEUE


#include <iostream>
#include <fstream>
#include "sllist.h"
using namespace std;

template<typename T>
class priority_queue
{
	private:
		singlyLinkedList<T> sll;
		node<T> * header;

	public:
		priority_queue();
		bool empty() const;
		void pop();

		//Push the new item into sll immediately before the first item with lower priority (lower value)
		void push(const T& item);

		int size() const;
		T& top();
		const T& top() const;

		//Print the internal sll to ostream, from the first node to the last
		friend ostream& operator<< (ostream& ostr, priority_queue& q);
};

template<typename T>
priority_queue<T>::priority_queue()
{
	header=(new node<T>());
}

template<typename T>
bool priority_queue<T>::empty() const
{
	return sll.empty();
}

template<typename T>
void priority_queue<T>::pop()
{
	sll.pop_front();
}

template<typename T>
void priority_queue<T>::push(const T& item)
{
	if(sll.empty())
	{
		sll.push_back(item);
		header->next=sll.begin();
		sll.begin()->next=header;
	}
	else
	{
		node<T>* temp=header->next;
		while((!(temp->nodeValue<item))&&temp!=header)
			temp=temp->next;
		if(temp==sll.begin())
			header->next=sll.insert(temp, item);
		else
			sll.insert(temp, item);
	}
}

template<typename T>
int priority_queue<T>::size() const
{
	return sll.size();
}

template<typename T>
T& priority_queue<T>::top()
{
	return sll.front();
}

template<typename T>
const T& priority_queue<T>::top() const
{
	return sll.front();
}

template<typename T>
ostream& operator<< (ostream& ostr, priority_queue<T>& q)
{
	node<T>* temp=q.header->next;
	while(temp!=q.header)
	{
		ostr<<(temp->nodeValue)<<' ';
		temp=temp->next;
	}
	return ostr;
}


#endif //PRIORITY_QUEUE